<?php

namespace Ulmus\Entity\Sqlite;

use Ulmus\EntityCollection;

/**
 * @Table('name' => "sqlite_master")
 */
class Schema
{
    use \Ulmus\EntityTrait;

    /**
     * @Id
     */
    public ? string $name;

    /**
     * @Field
     */
    public ? string $type;

    /**
     * @Field('name' => 'tbl_name')
     */
    public ? string $tableName;

    /**
     * @Field
     */
    public ? int $rootpage;

    /**
     * @Field
     */
    public ? string $sql;

    /**
     * @Relation('oneToMany', 'key' => 'tableName', 'foreignKey' => 'tableName', 'entity' => Schema::class)
     */
    public EntityCollection $columns;
}