<?php

namespace Ulmus\Query;

class Limit extends Fragment {

    const SQL_TOKEN = "LIMIT";
    
    public int $order = 90;

    public int $limit = 0;
    
    public function set($limit) : self
    {
        $this->limit = $limit;
        
        return $this;
    }

    public function render() : string
    {
        if ( $this->limit < 0 ) {
            throw new \Exception("An error occured trying to render the LIMIT fragment ; given value has to be > 0. Received {$this->limit}");
        }
        
        return $this->renderSegments([
            static::SQL_TOKEN, abs($this->limit)
        ]);
    }
}
